//
//  RLAppDelegate.m
//  RunLoop
//
//  Created by 國居 貴浩 on 12/06/21.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "RLAppDelegate.h"

@implementation RLAppDelegate

@synthesize window = _window;

- (void)dealloc
{
    [_window release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];

    //  1秒ごとに"run on main..."メッセージをコンソールに出力
    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(oneJob:) userInfo:@"main" repeats:YES];
    
    //  サブスレッド作成
    [self performSelectorInBackground:@selector(anotherThreadTask) withObject:nil];    
    
    return YES;
}

- (void)oneJob:(NSTimer*)timer
{
    printf("run on %s %p main=%p\n",
           [timer.userInfo UTF8String], 
           [NSThread currentThread],
           [NSThread mainThread]);
}

- (void)anotherThreadTask
{
    //  1秒ごとに"run on sub..."メッセージをコンソールに出力
    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(oneJob:) userInfo:@"sub" repeats:YES];    
//    [[NSRunLoop currentRunLoop] run];
}


- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

@end
